/*
 * blanco Framework
 * Copyright (C) 2004-2006 IGA Tosiki
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 */
package blanco.cg.transformer;

import java.io.BufferedWriter;
import java.io.IOException;
import java.util.List;

import blanco.cg.BlancoCgTransformer;
import blanco.cg.valueobject.BlancoCgClass;
import blanco.cg.valueobject.BlancoCgInterface;
import blanco.cg.valueobject.BlancoCgSourceFile;

/**
 * vO~O̎ނ܂钊ۓIȃgXtH[}[łB
 * 
 * @author IGA Tosiki
 */
abstract class AbstractBlancoCgTransformer implements BlancoCgTransformer {
    /**
     * R}hCɕ\ۂ̃bZ[WvtBbNXB
     */
    protected static final String CMDLINE_PREFIX = "cg: ";

    /**
     * \[Xt@C̊gq擾܂B
     * 
     * @return gqB
     */
    protected abstract String getSourceFileExt();

    /**
     * t@CNX܂̓C^tF[X瓱o܂B
     * 
     * ̃\bh́A܂t@Cm肵ĂȂꍇɂ̂݌Ăяo܂B
     * 
     * @param argSourceFile
     *            \[Xt@CIuWFNgB
     */
    protected void decideFilenameFromClassOrInterfaceName(
            final BlancoCgSourceFile argSourceFile) {
        // t@Cݒ̏ꍇɁABlancoCgSourceFile(t@C)̒Ɋ܂܂NXt@C݂̉܂B
        String className = null;
        for (int index = 0; index < argSourceFile.getClassList().size(); index++) {
            final BlancoCgClass cgClass = argSourceFile.getClassList().get(
                    index);

            className = cgClass.getName();
            break;
        }

        if (className == null) {
            // ܂t@C肵ĂȂꍇɂ́AC^tF[ẌꗗNX̓o݂܂B
            for (int index = 0; index < argSourceFile.getInterfaceList().size(); index++) {
                final BlancoCgInterface cgInterface = argSourceFile
                        .getInterfaceList().get(index);

                className = cgInterface.getName();
                break;
            }
        }

        if (className == null) {
            // łNXm肵Ȃꍇɂ͗OƂĈ܂B
            throw new IllegalArgumentException(
                    "\[Xt@C̎w肪Ȃ̂ŃNX̃XgNX̊m݂܂ANX͊mł܂łB");
        }

        // \[Xt@C̊mȂ܂B
        // o[IuWFNg̃\[Xt@CXVĂ_ɒӂĂB
        argSourceFile.setName(className);
    }

    /**
     * \[XR[hC^[֏o͂܂B
     * 
     * java.lang.String̃XgC^[ւƏo͂܂B
     * 
     * @param argSourceLines
     *            \[XR[hsXgB
     * @param writer
     *            o͐惉C^B
     * @throws IOException
     *             o͗OꍇB
     */
    protected void source2Writer(final List<java.lang.String> argSourceLines,
            final BufferedWriter writer) throws IOException {
        boolean isPastLineBlank = false;
        boolean isPastBlockStart = false;
        for (int index = 0; index < argSourceLines.size(); index++) {
            final String line = argSourceLines.get(index);

            // As̏o͂}܂B
            if (line.length() == 0) {
                if (isPastLineBlank) {
                    // OɈsł ͏o͂܂B
                    continue;
                }
                // ͋słB
                isPastLineBlank = true;
            } else {
                // ͋sł͂܂B
                isPastLineBlank = false;
            }

            if (isPastBlockStart && line.length() == 0) {
                // O񂪃ubÑX^[gŁA񂪋s̏ꍇɂ͏o͂܂B
                continue;
            }

            if (line.endsWith("{")) {
                isPastBlockStart = true;
            } else {
                isPastBlockStart = false;
            }

            // s 1s o͂܂B
            writer.write(line);
            writer.newLine();
        }
    }
}
